<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>API: OpenSim::ActuatorForceTargetFast Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script>
<script type="text/javascript" async="async" src="MathJax-2.7.0/MathJax.js"></script>
<link href="doxygen_developer.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="OpenSimLogoWhiteHorizontal_small.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">API
   &#160;<span id="projectnumber">4.4.1-2022-09-05-d4bb9bc34</span>
   </div>
   <div id="projectbrief">For C++ developers</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('classOpenSim_1_1ActuatorForceTargetFast.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="classOpenSim_1_1ActuatorForceTargetFast-members.html">List of all members</a> &#124;
<a href="#pub-methods">Public Member Functions</a>  </div>
  <div class="headertitle">
<div class="title">OpenSim::ActuatorForceTargetFast Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>A Computed <a class="el" href="classOpenSim_1_1Muscle.html" title="A base class for modeling a muscle-tendon actuator.">Muscle</a> <a class="el" href="classOpenSim_1_1Control.html" title="A class that represents a control in a dynamic simulation.">Control</a> (<a class="el" href="classOpenSim_1_1CMC.html" title="Computed Muscle Control (CMC) is an optimization-based control technique designed specifically for co...">CMC</a>) optimization target for controlling dynamic systems whose actuators may be themselves governed by differential equations, meaning there may be non-linear behavior and delays in force production.  
 <a href="classOpenSim_1_1ActuatorForceTargetFast.html#details">More...</a></p>
<div id="dynsection-0" onclick="return toggleVisibility(this)" class="dynheader closed" style="cursor:pointer;">
  <img id="dynsection-0-trigger" src="closed.png" alt="+"/> Inheritance diagram for OpenSim::ActuatorForceTargetFast:</div>
<div id="dynsection-0-summary" class="dynsummary" style="display:block;">
</div>
<div id="dynsection-0-content" class="dyncontent" style="display:none;">
 <div class="center">
  <img src="classOpenSim_1_1ActuatorForceTargetFast.png" usemap="#OpenSim::ActuatorForceTargetFast_map" alt=""/>
  <map id="OpenSim::ActuatorForceTargetFast_map" name="OpenSim::ActuatorForceTargetFast_map">
<area href="classOpenSim_1_1OptimizationTarget.html" title="This class provides an interface specification for optimizing redundant systems." alt="OpenSim::OptimizationTarget" shape="rect" coords="0,56,211,80"/>
  </map>
</div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:af176976afcec7ba72c2c767599a95687"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1ActuatorForceTargetFast.html#af176976afcec7ba72c2c767599a95687">~ActuatorForceTargetFast</a> ()</td></tr>
<tr class="separator:af176976afcec7ba72c2c767599a95687"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4b4807cf328add0faa792a637ce0434c"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1ActuatorForceTargetFast.html#a4b4807cf328add0faa792a637ce0434c">ActuatorForceTargetFast</a> (SimTK::State &amp;s, int aNX, <a class="el" href="classOpenSim_1_1CMC.html">CMC</a> *aController)</td></tr>
<tr class="separator:a4b4807cf328add0faa792a637ce0434c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae917b78498bf34c87da772b619728a30"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1ActuatorForceTargetFast.html#ae917b78498bf34c87da772b619728a30">prepareToOptimize</a> (SimTK::State &amp;s, double *x) override</td></tr>
<tr class="separator:ae917b78498bf34c87da772b619728a30"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a99ebe726b85a64663c8d9ce4e260ac62"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1ActuatorForceTargetFast.html#a99ebe726b85a64663c8d9ce4e260ac62">objectiveFunc</a> (const SimTK::Vector &amp;aF, bool new_coefficients, SimTK::Real &amp;rP) const override</td></tr>
<tr class="separator:a99ebe726b85a64663c8d9ce4e260ac62"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a629fc94478f82abb33a87607daaccae7"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1ActuatorForceTargetFast.html#a629fc94478f82abb33a87607daaccae7">gradientFunc</a> (const SimTK::Vector &amp;x, bool new_coefficients, SimTK::Vector &amp;gradient) const override</td></tr>
<tr class="separator:a629fc94478f82abb33a87607daaccae7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4dad49cf6019ece2b7a32b8c20ae9325"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1ActuatorForceTargetFast.html#a4dad49cf6019ece2b7a32b8c20ae9325">constraintFunc</a> (const SimTK::Vector &amp;x, bool new_coefficients, SimTK::Vector &amp;constraints) const override</td></tr>
<tr class="separator:a4dad49cf6019ece2b7a32b8c20ae9325"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa76d1eeb6a4315ed91c22074e1a408b4"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1ActuatorForceTargetFast.html#aa76d1eeb6a4315ed91c22074e1a408b4">constraintJacobian</a> (const SimTK::Vector &amp;x, bool new_coefficients, SimTK::Matrix &amp;jac) const override</td></tr>
<tr class="separator:aa76d1eeb6a4315ed91c22074e1a408b4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abdcb59f7f17e303158f294502d885c9d"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOpenSim_1_1CMC.html">CMC</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1ActuatorForceTargetFast.html#abdcb59f7f17e303158f294502d885c9d">getController</a> ()</td></tr>
<tr class="separator:abdcb59f7f17e303158f294502d885c9d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classOpenSim_1_1OptimizationTarget"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classOpenSim_1_1OptimizationTarget')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classOpenSim_1_1OptimizationTarget.html">OpenSim::OptimizationTarget</a></td></tr>
<tr class="memitem:a731378dc81796e3ed09bccee16bd48d4 inherit pub_methods_classOpenSim_1_1OptimizationTarget"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1OptimizationTarget.html#a731378dc81796e3ed09bccee16bd48d4">OptimizationTarget</a> (int aNX=0)</td></tr>
<tr class="separator:a731378dc81796e3ed09bccee16bd48d4 inherit pub_methods_classOpenSim_1_1OptimizationTarget"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a129e9fc55ee34e9e19e3af51caa5e549 inherit pub_methods_classOpenSim_1_1OptimizationTarget"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1OptimizationTarget.html#a129e9fc55ee34e9e19e3af51caa5e549">setNumParameters</a> (const int aNX)</td></tr>
<tr class="separator:a129e9fc55ee34e9e19e3af51caa5e549 inherit pub_methods_classOpenSim_1_1OptimizationTarget"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6b9a59eb66d062d41d88e7ffdff2b672 inherit pub_methods_classOpenSim_1_1OptimizationTarget"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1OptimizationTarget.html#a6b9a59eb66d062d41d88e7ffdff2b672">setDX</a> (double aVal)</td></tr>
<tr class="separator:a6b9a59eb66d062d41d88e7ffdff2b672 inherit pub_methods_classOpenSim_1_1OptimizationTarget"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a52ea0f55facc22653fdab53bc5e38683 inherit pub_methods_classOpenSim_1_1OptimizationTarget"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1OptimizationTarget.html#a52ea0f55facc22653fdab53bc5e38683">setDX</a> (int aIndex, double aVal)</td></tr>
<tr class="separator:a52ea0f55facc22653fdab53bc5e38683 inherit pub_methods_classOpenSim_1_1OptimizationTarget"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1cbd3667b9218a9de9013a331b9dcb37 inherit pub_methods_classOpenSim_1_1OptimizationTarget"><td class="memItemLeft" align="right" valign="top">double&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1OptimizationTarget.html#a1cbd3667b9218a9de9013a331b9dcb37">getDX</a> (int aIndex)</td></tr>
<tr class="separator:a1cbd3667b9218a9de9013a331b9dcb37 inherit pub_methods_classOpenSim_1_1OptimizationTarget"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4fdf5dd2ea86e145ec77d79b58cd7bc0 inherit pub_methods_classOpenSim_1_1OptimizationTarget"><td class="memItemLeft" align="right" valign="top">double *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1OptimizationTarget.html#a4fdf5dd2ea86e145ec77d79b58cd7bc0">getDXArray</a> ()</td></tr>
<tr class="separator:a4fdf5dd2ea86e145ec77d79b58cd7bc0 inherit pub_methods_classOpenSim_1_1OptimizationTarget"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1d5baf46187f3415d1d5459a46c5c96a inherit pub_methods_classOpenSim_1_1OptimizationTarget"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1OptimizationTarget.html#a1d5baf46187f3415d1d5459a46c5c96a">validatePerturbationSize</a> (double &amp;aSize)</td></tr>
<tr class="separator:a1d5baf46187f3415d1d5459a46c5c96a inherit pub_methods_classOpenSim_1_1OptimizationTarget"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac4709e9038c473ed88b8bb3dcd840d4c inherit pub_methods_classOpenSim_1_1OptimizationTarget"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1OptimizationTarget.html#ac4709e9038c473ed88b8bb3dcd840d4c">printPerformance</a> (double *x)</td></tr>
<tr class="separator:ac4709e9038c473ed88b8bb3dcd840d4c inherit pub_methods_classOpenSim_1_1OptimizationTarget"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="inherited"></a>
Additional Inherited Members</h2></td></tr>
<tr class="inherit_header pub_static_methods_classOpenSim_1_1OptimizationTarget"><td colspan="2" onclick="javascript:toggleInherit('pub_static_methods_classOpenSim_1_1OptimizationTarget')"><img src="closed.png" alt="-"/>&#160;Static Public Member Functions inherited from <a class="el" href="classOpenSim_1_1OptimizationTarget.html">OpenSim::OptimizationTarget</a></td></tr>
<tr class="memitem:a7f08da8292776b2cb834409c2a2b68c9 inherit pub_static_methods_classOpenSim_1_1OptimizationTarget"><td class="memItemLeft" align="right" valign="top">static int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1OptimizationTarget.html#a7f08da8292776b2cb834409c2a2b68c9">CentralDifferencesConstraint</a> (const <a class="el" href="classOpenSim_1_1OptimizationTarget.html">OptimizationTarget</a> *aTarget, double *dx, const SimTK::Vector &amp;x, SimTK::Matrix &amp;jacobian)</td></tr>
<tr class="separator:a7f08da8292776b2cb834409c2a2b68c9 inherit pub_static_methods_classOpenSim_1_1OptimizationTarget"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a955bc8a7fdbe6b6619a34de01d7669b3 inherit pub_static_methods_classOpenSim_1_1OptimizationTarget"><td class="memItemLeft" align="right" valign="top">static int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1OptimizationTarget.html#a955bc8a7fdbe6b6619a34de01d7669b3">CentralDifferences</a> (const <a class="el" href="classOpenSim_1_1OptimizationTarget.html">OptimizationTarget</a> *aTarget, double *dx, const SimTK::Vector &amp;x, SimTK::Vector &amp;dpdx)</td></tr>
<tr class="separator:a955bc8a7fdbe6b6619a34de01d7669b3 inherit pub_static_methods_classOpenSim_1_1OptimizationTarget"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a662262b4292885161905998ef41171a4 inherit pub_static_methods_classOpenSim_1_1OptimizationTarget"><td class="memItemLeft" align="right" valign="top">static int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1OptimizationTarget.html#a662262b4292885161905998ef41171a4">ForwardDifferences</a> (const <a class="el" href="classOpenSim_1_1OptimizationTarget.html">OptimizationTarget</a> *aTarget, double *dx, const SimTK::Vector &amp;x, SimTK::Vector &amp;dpdx)</td></tr>
<tr class="separator:a662262b4292885161905998ef41171a4 inherit pub_static_methods_classOpenSim_1_1OptimizationTarget"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_static_attribs_classOpenSim_1_1OptimizationTarget"><td colspan="2" onclick="javascript:toggleInherit('pub_static_attribs_classOpenSim_1_1OptimizationTarget')"><img src="closed.png" alt="-"/>&#160;Static Public Attributes inherited from <a class="el" href="classOpenSim_1_1OptimizationTarget.html">OpenSim::OptimizationTarget</a></td></tr>
<tr class="memitem:a819b5e73607c9462b3b719e701a30ad5 inherit pub_static_attribs_classOpenSim_1_1OptimizationTarget"><td class="memItemLeft" align="right" valign="top">static const double&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1OptimizationTarget.html#a819b5e73607c9462b3b719e701a30ad5">SMALLDX</a></td></tr>
<tr class="memdesc:a819b5e73607c9462b3b719e701a30ad5 inherit pub_static_attribs_classOpenSim_1_1OptimizationTarget"><td class="mdescLeft">&#160;</td><td class="mdescRight">Smallest allowable perturbation size for computing derivatives.  <a href="classOpenSim_1_1OptimizationTarget.html#a819b5e73607c9462b3b719e701a30ad5">More...</a><br /></td></tr>
<tr class="separator:a819b5e73607c9462b3b719e701a30ad5 inherit pub_static_attribs_classOpenSim_1_1OptimizationTarget"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pro_attribs_classOpenSim_1_1OptimizationTarget"><td colspan="2" onclick="javascript:toggleInherit('pro_attribs_classOpenSim_1_1OptimizationTarget')"><img src="closed.png" alt="-"/>&#160;Protected Attributes inherited from <a class="el" href="classOpenSim_1_1OptimizationTarget.html">OpenSim::OptimizationTarget</a></td></tr>
<tr class="memitem:a0fb43c9136628095d64d3e6eda808f57 inherit pro_attribs_classOpenSim_1_1OptimizationTarget"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOpenSim_1_1Array.html">Array</a>&lt; double &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1OptimizationTarget.html#a0fb43c9136628095d64d3e6eda808f57">_dx</a></td></tr>
<tr class="memdesc:a0fb43c9136628095d64d3e6eda808f57 inherit pro_attribs_classOpenSim_1_1OptimizationTarget"><td class="mdescLeft">&#160;</td><td class="mdescRight">Perturbation size for computing numerical derivatives.  <a href="classOpenSim_1_1OptimizationTarget.html#a0fb43c9136628095d64d3e6eda808f57">More...</a><br /></td></tr>
<tr class="separator:a0fb43c9136628095d64d3e6eda808f57 inherit pro_attribs_classOpenSim_1_1OptimizationTarget"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description </h2>
<div class="textblock"><p>A Computed <a class="el" href="classOpenSim_1_1Muscle.html" title="A base class for modeling a muscle-tendon actuator.">Muscle</a> <a class="el" href="classOpenSim_1_1Control.html" title="A class that represents a control in a dynamic simulation.">Control</a> (<a class="el" href="classOpenSim_1_1CMC.html" title="Computed Muscle Control (CMC) is an optimization-based control technique designed specifically for co...">CMC</a>) optimization target for controlling dynamic systems whose actuators may be themselves governed by differential equations, meaning there may be non-linear behavior and delays in force production. </p>
<p>The performance criterion is the sum of actuator stresses squared. The desired accelerations are achieved by imposing a set of constraints. The desired accelerations are computed according to the Proportional Derivative (PD) control in order to drive the dynamic model toward a set of target kinematic trajectories.</p>
<p>Because the desired accelerations are achieved by imposing a set of linear hard constraints, this optimization target can fail if the desired accelerations cannot be achieved. To insure that the constraints can be achieved, a number of sufficiently strong actuators can be added to the model. Alternatively, one can use a different optimization target <a class="el" href="classOpenSim_1_1ActuatorForceTarget.html" title="A Computed Muscle Control (CMC) optimization target for controlling dynamic systems whose actuators m...">ActuatorForceTarget</a>. The benefits of using the fast target are both speed and tracking accuracy.</p>
<dl class="section version"><dt>Version</dt><dd>1.0 </dd></dl>
<dl class="section author"><dt>Author</dt><dd>Frank C. Anderson </dd></dl>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="af176976afcec7ba72c2c767599a95687"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af176976afcec7ba72c2c767599a95687">&#9670;&nbsp;</a></span>~ActuatorForceTargetFast()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual OpenSim::ActuatorForceTargetFast::~ActuatorForceTargetFast </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="a4b4807cf328add0faa792a637ce0434c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a4b4807cf328add0faa792a637ce0434c">&#9670;&nbsp;</a></span>ActuatorForceTargetFast()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">OpenSim::ActuatorForceTargetFast::ActuatorForceTargetFast </td>
          <td>(</td>
          <td class="paramtype">SimTK::State &amp;&#160;</td>
          <td class="paramname"><em>s</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>aNX</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOpenSim_1_1CMC.html">CMC</a> *&#160;</td>
          <td class="paramname"><em>aController</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a4dad49cf6019ece2b7a32b8c20ae9325"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a4dad49cf6019ece2b7a32b8c20ae9325">&#9670;&nbsp;</a></span>constraintFunc()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">int OpenSim::ActuatorForceTargetFast::constraintFunc </td>
          <td>(</td>
          <td class="paramtype">const SimTK::Vector &amp;&#160;</td>
          <td class="paramname"><em>x</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>new_coefficients</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">SimTK::Vector &amp;&#160;</td>
          <td class="paramname"><em>constraints</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="aa76d1eeb6a4315ed91c22074e1a408b4"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa76d1eeb6a4315ed91c22074e1a408b4">&#9670;&nbsp;</a></span>constraintJacobian()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">int OpenSim::ActuatorForceTargetFast::constraintJacobian </td>
          <td>(</td>
          <td class="paramtype">const SimTK::Vector &amp;&#160;</td>
          <td class="paramname"><em>x</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>new_coefficients</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">SimTK::Matrix &amp;&#160;</td>
          <td class="paramname"><em>jac</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="abdcb59f7f17e303158f294502d885c9d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#abdcb59f7f17e303158f294502d885c9d">&#9670;&nbsp;</a></span>getController()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOpenSim_1_1CMC.html">CMC</a>* OpenSim::ActuatorForceTargetFast::getController </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="a629fc94478f82abb33a87607daaccae7"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a629fc94478f82abb33a87607daaccae7">&#9670;&nbsp;</a></span>gradientFunc()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">int OpenSim::ActuatorForceTargetFast::gradientFunc </td>
          <td>(</td>
          <td class="paramtype">const SimTK::Vector &amp;&#160;</td>
          <td class="paramname"><em>x</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>new_coefficients</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">SimTK::Vector &amp;&#160;</td>
          <td class="paramname"><em>gradient</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="a99ebe726b85a64663c8d9ce4e260ac62"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a99ebe726b85a64663c8d9ce4e260ac62">&#9670;&nbsp;</a></span>objectiveFunc()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">int OpenSim::ActuatorForceTargetFast::objectiveFunc </td>
          <td>(</td>
          <td class="paramtype">const SimTK::Vector &amp;&#160;</td>
          <td class="paramname"><em>aF</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>new_coefficients</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">SimTK::Real &amp;&#160;</td>
          <td class="paramname"><em>rP</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="ae917b78498bf34c87da772b619728a30"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae917b78498bf34c87da772b619728a30">&#9670;&nbsp;</a></span>prepareToOptimize()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool OpenSim::ActuatorForceTargetFast::prepareToOptimize </td>
          <td>(</td>
          <td class="paramtype">SimTK::State &amp;&#160;</td>
          <td class="paramname"><em>s</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double *&#160;</td>
          <td class="paramname"><em>x</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Reimplemented from <a class="el" href="classOpenSim_1_1OptimizationTarget.html#a50a0ba65df75d0043904a453804c8e41">OpenSim::OptimizationTarget</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>OpenSim/Tools/ActuatorForceTargetFast.h</li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="namespaceOpenSim.html">OpenSim</a></li><li class="navelem"><a class="el" href="classOpenSim_1_1ActuatorForceTargetFast.html">ActuatorForceTargetFast</a></li>
    <li class="footer">Generated on Mon Sep 5 2022 20:49:17 for API by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.0 </li>
  </ul>
</div>
</body>
</html>
